"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiGatewayV2Service = exports.makeApiGatewayV2Service = void 0;
/**
 * @since 1.0.0
 */
const client_apigatewayv2_1 = require("@aws-sdk/client-apigatewayv2");
const commons_1 = require("@effect-aws/commons");
const effect_1 = require("effect");
const Instance = __importStar(require("./ApiGatewayV2ClientInstance.js"));
const ApiGatewayV2ServiceConfig = __importStar(require("./ApiGatewayV2ServiceConfig.js"));
const Errors_js_1 = require("./Errors.js");
const commands = {
    CreateApiCommand: client_apigatewayv2_1.CreateApiCommand,
    CreateApiMappingCommand: client_apigatewayv2_1.CreateApiMappingCommand,
    CreateAuthorizerCommand: client_apigatewayv2_1.CreateAuthorizerCommand,
    CreateDeploymentCommand: client_apigatewayv2_1.CreateDeploymentCommand,
    CreateDomainNameCommand: client_apigatewayv2_1.CreateDomainNameCommand,
    CreateIntegrationCommand: client_apigatewayv2_1.CreateIntegrationCommand,
    CreateIntegrationResponseCommand: client_apigatewayv2_1.CreateIntegrationResponseCommand,
    CreateModelCommand: client_apigatewayv2_1.CreateModelCommand,
    CreateRouteCommand: client_apigatewayv2_1.CreateRouteCommand,
    CreateRouteResponseCommand: client_apigatewayv2_1.CreateRouteResponseCommand,
    CreateStageCommand: client_apigatewayv2_1.CreateStageCommand,
    CreateVpcLinkCommand: client_apigatewayv2_1.CreateVpcLinkCommand,
    DeleteAccessLogSettingsCommand: client_apigatewayv2_1.DeleteAccessLogSettingsCommand,
    DeleteApiCommand: client_apigatewayv2_1.DeleteApiCommand,
    DeleteApiMappingCommand: client_apigatewayv2_1.DeleteApiMappingCommand,
    DeleteAuthorizerCommand: client_apigatewayv2_1.DeleteAuthorizerCommand,
    DeleteCorsConfigurationCommand: client_apigatewayv2_1.DeleteCorsConfigurationCommand,
    DeleteDeploymentCommand: client_apigatewayv2_1.DeleteDeploymentCommand,
    DeleteDomainNameCommand: client_apigatewayv2_1.DeleteDomainNameCommand,
    DeleteIntegrationCommand: client_apigatewayv2_1.DeleteIntegrationCommand,
    DeleteIntegrationResponseCommand: client_apigatewayv2_1.DeleteIntegrationResponseCommand,
    DeleteModelCommand: client_apigatewayv2_1.DeleteModelCommand,
    DeleteRouteCommand: client_apigatewayv2_1.DeleteRouteCommand,
    DeleteRouteRequestParameterCommand: client_apigatewayv2_1.DeleteRouteRequestParameterCommand,
    DeleteRouteResponseCommand: client_apigatewayv2_1.DeleteRouteResponseCommand,
    DeleteRouteSettingsCommand: client_apigatewayv2_1.DeleteRouteSettingsCommand,
    DeleteStageCommand: client_apigatewayv2_1.DeleteStageCommand,
    DeleteVpcLinkCommand: client_apigatewayv2_1.DeleteVpcLinkCommand,
    ExportApiCommand: client_apigatewayv2_1.ExportApiCommand,
    GetApiCommand: client_apigatewayv2_1.GetApiCommand,
    GetApiMappingCommand: client_apigatewayv2_1.GetApiMappingCommand,
    GetApiMappingsCommand: client_apigatewayv2_1.GetApiMappingsCommand,
    GetApisCommand: client_apigatewayv2_1.GetApisCommand,
    GetAuthorizerCommand: client_apigatewayv2_1.GetAuthorizerCommand,
    GetAuthorizersCommand: client_apigatewayv2_1.GetAuthorizersCommand,
    GetDeploymentCommand: client_apigatewayv2_1.GetDeploymentCommand,
    GetDeploymentsCommand: client_apigatewayv2_1.GetDeploymentsCommand,
    GetDomainNameCommand: client_apigatewayv2_1.GetDomainNameCommand,
    GetDomainNamesCommand: client_apigatewayv2_1.GetDomainNamesCommand,
    GetIntegrationCommand: client_apigatewayv2_1.GetIntegrationCommand,
    GetIntegrationResponseCommand: client_apigatewayv2_1.GetIntegrationResponseCommand,
    GetIntegrationResponsesCommand: client_apigatewayv2_1.GetIntegrationResponsesCommand,
    GetIntegrationsCommand: client_apigatewayv2_1.GetIntegrationsCommand,
    GetModelCommand: client_apigatewayv2_1.GetModelCommand,
    GetModelTemplateCommand: client_apigatewayv2_1.GetModelTemplateCommand,
    GetModelsCommand: client_apigatewayv2_1.GetModelsCommand,
    GetRouteCommand: client_apigatewayv2_1.GetRouteCommand,
    GetRouteResponseCommand: client_apigatewayv2_1.GetRouteResponseCommand,
    GetRouteResponsesCommand: client_apigatewayv2_1.GetRouteResponsesCommand,
    GetRoutesCommand: client_apigatewayv2_1.GetRoutesCommand,
    GetStageCommand: client_apigatewayv2_1.GetStageCommand,
    GetStagesCommand: client_apigatewayv2_1.GetStagesCommand,
    GetTagsCommand: client_apigatewayv2_1.GetTagsCommand,
    GetVpcLinkCommand: client_apigatewayv2_1.GetVpcLinkCommand,
    GetVpcLinksCommand: client_apigatewayv2_1.GetVpcLinksCommand,
    ImportApiCommand: client_apigatewayv2_1.ImportApiCommand,
    ReimportApiCommand: client_apigatewayv2_1.ReimportApiCommand,
    ResetAuthorizersCacheCommand: client_apigatewayv2_1.ResetAuthorizersCacheCommand,
    TagResourceCommand: client_apigatewayv2_1.TagResourceCommand,
    UntagResourceCommand: client_apigatewayv2_1.UntagResourceCommand,
    UpdateApiCommand: client_apigatewayv2_1.UpdateApiCommand,
    UpdateApiMappingCommand: client_apigatewayv2_1.UpdateApiMappingCommand,
    UpdateAuthorizerCommand: client_apigatewayv2_1.UpdateAuthorizerCommand,
    UpdateDeploymentCommand: client_apigatewayv2_1.UpdateDeploymentCommand,
    UpdateDomainNameCommand: client_apigatewayv2_1.UpdateDomainNameCommand,
    UpdateIntegrationCommand: client_apigatewayv2_1.UpdateIntegrationCommand,
    UpdateIntegrationResponseCommand: client_apigatewayv2_1.UpdateIntegrationResponseCommand,
    UpdateModelCommand: client_apigatewayv2_1.UpdateModelCommand,
    UpdateRouteCommand: client_apigatewayv2_1.UpdateRouteCommand,
    UpdateRouteResponseCommand: client_apigatewayv2_1.UpdateRouteResponseCommand,
    UpdateStageCommand: client_apigatewayv2_1.UpdateStageCommand,
    UpdateVpcLinkCommand: client_apigatewayv2_1.UpdateVpcLinkCommand,
};
/**
 * @since 1.0.0
 * @category constructors
 */
exports.makeApiGatewayV2Service = effect_1.Effect.gen(function* () {
    const client = yield* Instance.ApiGatewayV2ClientInstance;
    return yield* commons_1.Service.fromClientAndCommands(client, commands, {
        errorTags: Errors_js_1.AllServiceErrors,
        resolveClientConfig: ApiGatewayV2ServiceConfig.toApiGatewayV2ClientConfig,
    });
});
/**
 * @since 1.0.0
 * @category models
 */
class ApiGatewayV2Service extends effect_1.Effect.Tag("@effect-aws/client-api-gateway-v2/ApiGatewayV2Service")() {
    static defaultLayer = effect_1.Layer.effect(this, exports.makeApiGatewayV2Service).pipe(effect_1.Layer.provide(Instance.layer));
    static layer = (config) => effect_1.Layer.effect(this, exports.makeApiGatewayV2Service).pipe(effect_1.Layer.provide(Instance.layer), effect_1.Layer.provide(ApiGatewayV2ServiceConfig.setApiGatewayV2ServiceConfig(config)));
    static baseLayer = (evaluate) => effect_1.Layer.effect(this, exports.makeApiGatewayV2Service).pipe(effect_1.Layer.provide(effect_1.Layer.effect(Instance.ApiGatewayV2ClientInstance, effect_1.Effect.map(ApiGatewayV2ServiceConfig.toApiGatewayV2ClientConfig, evaluate))));
}
exports.ApiGatewayV2Service = ApiGatewayV2Service;
//# sourceMappingURL=ApiGatewayV2Service.js.map