/**
 * @since 1.0.0
 */
import type { ApiGatewayV2ClientConfig } from "@aws-sdk/client-apigatewayv2";
import { Effect, Layer } from "effect";
import type { ApiGatewayV2Service } from "./ApiGatewayV2Service.js";
/**
 * @since 1.0.0
 * @category api-gateway-v2 service config
 */
export declare const withApiGatewayV2ServiceConfig: {
    (config: ApiGatewayV2Service.Config): <A, E, R>(effect: Effect.Effect<A, E, R>) => Effect.Effect<A, E, R>;
    <A, E, R>(effect: Effect.Effect<A, E, R>, config: ApiGatewayV2Service.Config): Effect.Effect<A, E, R>;
};
/**
 * @since 1.0.0
 * @category api-gateway-v2 service config
 */
export declare const setApiGatewayV2ServiceConfig: (config: ApiGatewayV2Service.Config) => Layer.Layer<never, never, never>;
/**
 * @since 1.0.0
 * @category adapters
 */
export declare const toApiGatewayV2ClientConfig: Effect.Effect<ApiGatewayV2ClientConfig>;
//# sourceMappingURL=ApiGatewayV2ServiceConfig.d.ts.map