"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toApiGatewayV2ClientConfig = exports.setApiGatewayV2ServiceConfig = exports.withApiGatewayV2ServiceConfig = void 0;
const commons_1 = require("@effect-aws/commons");
const effect_1 = require("effect");
const Function_1 = require("effect/Function");
const GlobalValue_1 = require("effect/GlobalValue");
/**
 * @since 1.0.0
 * @category api-gateway-v2 service config
 */
const currentApiGatewayV2ServiceConfig = (0, GlobalValue_1.globalValue)("@effect-aws/client-api-gateway-v2/currentApiGatewayV2ServiceConfig", () => effect_1.FiberRef.unsafeMake({}));
/**
 * @since 1.0.0
 * @category api-gateway-v2 service config
 */
exports.withApiGatewayV2ServiceConfig = (0, Function_1.dual)(2, (effect, config) => effect_1.Effect.locally(effect, currentApiGatewayV2ServiceConfig, config));
/**
 * @since 1.0.0
 * @category api-gateway-v2 service config
 */
const setApiGatewayV2ServiceConfig = (config) => effect_1.Layer.locallyScoped(currentApiGatewayV2ServiceConfig, config);
exports.setApiGatewayV2ServiceConfig = setApiGatewayV2ServiceConfig;
/**
 * @since 1.0.0
 * @category adapters
 */
exports.toApiGatewayV2ClientConfig = effect_1.Effect.gen(function* () {
    const { logger: serviceLogger, ...config } = yield* effect_1.FiberRef.get(currentApiGatewayV2ServiceConfig);
    const logger = serviceLogger === true
        ? yield* commons_1.ServiceLogger.toClientLogger(commons_1.ServiceLogger.defaultServiceLogger)
        : (serviceLogger ? yield* commons_1.ServiceLogger.toClientLogger(commons_1.ServiceLogger.make(serviceLogger)) : undefined);
    return { logger, ...config };
});
//# sourceMappingURL=ApiGatewayV2ServiceConfig.js.map