/**
 * @since 1.0.0
 */
import { CreateApiCommand, CreateApiMappingCommand, CreateAuthorizerCommand, CreateDeploymentCommand, CreateDomainNameCommand, CreateIntegrationCommand, CreateIntegrationResponseCommand, CreateModelCommand, CreateRouteCommand, CreateRouteResponseCommand, CreateStageCommand, CreateVpcLinkCommand, DeleteAccessLogSettingsCommand, DeleteApiCommand, DeleteApiMappingCommand, DeleteAuthorizerCommand, DeleteCorsConfigurationCommand, DeleteDeploymentCommand, DeleteDomainNameCommand, DeleteIntegrationCommand, DeleteIntegrationResponseCommand, DeleteModelCommand, DeleteRouteCommand, DeleteRouteRequestParameterCommand, DeleteRouteResponseCommand, DeleteRouteSettingsCommand, DeleteStageCommand, DeleteVpcLinkCommand, ExportApiCommand, GetApiCommand, GetApiMappingCommand, GetApiMappingsCommand, GetApisCommand, GetAuthorizerCommand, GetAuthorizersCommand, GetDeploymentCommand, GetDeploymentsCommand, GetDomainNameCommand, GetDomainNamesCommand, GetIntegrationCommand, GetIntegrationResponseCommand, GetIntegrationResponsesCommand, GetIntegrationsCommand, GetModelCommand, GetModelsCommand, GetModelTemplateCommand, GetRouteCommand, GetRouteResponseCommand, GetRouteResponsesCommand, GetRoutesCommand, GetStageCommand, GetStagesCommand, GetTagsCommand, GetVpcLinkCommand, GetVpcLinksCommand, ImportApiCommand, ReimportApiCommand, ResetAuthorizersCacheCommand, TagResourceCommand, UntagResourceCommand, UpdateApiCommand, UpdateApiMappingCommand, UpdateAuthorizerCommand, UpdateDeploymentCommand, UpdateDomainNameCommand, UpdateIntegrationCommand, UpdateIntegrationResponseCommand, UpdateModelCommand, UpdateRouteCommand, UpdateRouteResponseCommand, UpdateStageCommand, UpdateVpcLinkCommand, } from "@aws-sdk/client-apigatewayv2";
import { Service } from "@effect-aws/commons";
import { Effect, Layer } from "effect";
import * as Instance from "./ApiGatewayV2ClientInstance.js";
import * as ApiGatewayV2ServiceConfig from "./ApiGatewayV2ServiceConfig.js";
import { AllServiceErrors } from "./Errors.js";
const commands = {
    CreateApiCommand,
    CreateApiMappingCommand,
    CreateAuthorizerCommand,
    CreateDeploymentCommand,
    CreateDomainNameCommand,
    CreateIntegrationCommand,
    CreateIntegrationResponseCommand,
    CreateModelCommand,
    CreateRouteCommand,
    CreateRouteResponseCommand,
    CreateStageCommand,
    CreateVpcLinkCommand,
    DeleteAccessLogSettingsCommand,
    DeleteApiCommand,
    DeleteApiMappingCommand,
    DeleteAuthorizerCommand,
    DeleteCorsConfigurationCommand,
    DeleteDeploymentCommand,
    DeleteDomainNameCommand,
    DeleteIntegrationCommand,
    DeleteIntegrationResponseCommand,
    DeleteModelCommand,
    DeleteRouteCommand,
    DeleteRouteRequestParameterCommand,
    DeleteRouteResponseCommand,
    DeleteRouteSettingsCommand,
    DeleteStageCommand,
    DeleteVpcLinkCommand,
    ExportApiCommand,
    GetApiCommand,
    GetApiMappingCommand,
    GetApiMappingsCommand,
    GetApisCommand,
    GetAuthorizerCommand,
    GetAuthorizersCommand,
    GetDeploymentCommand,
    GetDeploymentsCommand,
    GetDomainNameCommand,
    GetDomainNamesCommand,
    GetIntegrationCommand,
    GetIntegrationResponseCommand,
    GetIntegrationResponsesCommand,
    GetIntegrationsCommand,
    GetModelCommand,
    GetModelTemplateCommand,
    GetModelsCommand,
    GetRouteCommand,
    GetRouteResponseCommand,
    GetRouteResponsesCommand,
    GetRoutesCommand,
    GetStageCommand,
    GetStagesCommand,
    GetTagsCommand,
    GetVpcLinkCommand,
    GetVpcLinksCommand,
    ImportApiCommand,
    ReimportApiCommand,
    ResetAuthorizersCacheCommand,
    TagResourceCommand,
    UntagResourceCommand,
    UpdateApiCommand,
    UpdateApiMappingCommand,
    UpdateAuthorizerCommand,
    UpdateDeploymentCommand,
    UpdateDomainNameCommand,
    UpdateIntegrationCommand,
    UpdateIntegrationResponseCommand,
    UpdateModelCommand,
    UpdateRouteCommand,
    UpdateRouteResponseCommand,
    UpdateStageCommand,
    UpdateVpcLinkCommand,
};
/**
 * @since 1.0.0
 * @category constructors
 */
export const makeApiGatewayV2Service = Effect.gen(function* () {
    const client = yield* Instance.ApiGatewayV2ClientInstance;
    return yield* Service.fromClientAndCommands(client, commands, {
        errorTags: AllServiceErrors,
        resolveClientConfig: ApiGatewayV2ServiceConfig.toApiGatewayV2ClientConfig,
    });
});
/**
 * @since 1.0.0
 * @category models
 */
export class ApiGatewayV2Service extends Effect.Tag("@effect-aws/client-api-gateway-v2/ApiGatewayV2Service")() {
    static defaultLayer = Layer.effect(this, makeApiGatewayV2Service).pipe(Layer.provide(Instance.layer));
    static layer = (config) => Layer.effect(this, makeApiGatewayV2Service).pipe(Layer.provide(Instance.layer), Layer.provide(ApiGatewayV2ServiceConfig.setApiGatewayV2ServiceConfig(config)));
    static baseLayer = (evaluate) => Layer.effect(this, makeApiGatewayV2Service).pipe(Layer.provide(Layer.effect(Instance.ApiGatewayV2ClientInstance, Effect.map(ApiGatewayV2ServiceConfig.toApiGatewayV2ClientConfig, evaluate))));
}
//# sourceMappingURL=ApiGatewayV2Service.js.map